 DEFINE PAGE7, SPACE=ROM
 SEGMENT PAGE7

 extern defenitionpg1
 extern defenitionpg2
 extern defenitionpg3
 extern defenitionpg4
 extern pics
 extern quotez
 public equationspg

 include "ti83plus.inc"
 include "Zstats-JumpTable.inc"

EXT_APP equ 1   ;This definition is required of all apps
cseg            ;This linker directive is required of all apps.

equationspg:
  B_CALL ClrLCDFull
  LD HL,L1name
  B_CALL Mov9ToOP1
  B_CALL FindSym ; find in symbol table,
  AND 1Fh ; ACC = data type information,
  EX DE,HL ; HL = pointer to data storage
  B_CALL DataSize ; DE = size of data storage
  EX DE,HL
  ld a,h
  cp 0
  jp nz, next
  ld a,l
  cp 2
  jp z, stupid
next:
  ld a,(curCol)
  inc a
  ld c,a
  ld a,1
  ld (curcol),a
  ld a,c
  cp 190
  jp z,FNSstrt
  cp 191
  jp z,IQRstrt
  cp 192
  jp z,meanstrt
  cp 193
  jp z,varstrt
  cp 194
  jp z,devstrt
  cp 195
  jp z,outlstrt
;-------------------------------------
;-     5-Number Summary              -
;-------------------------------------
FNSstrt:
  B_CALL ZeroOP1
  ld HL,fns1
  ld a,0
  ld (pencol),a
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,8
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,16
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,24
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,32
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,40
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,48
  ld (penrow),a
  call vputs0
  call ovs
;calculations and numeric display
  ld a,0
  ld (pencol),a
  ld (penrow),a
  ld HL,0
  ld HL,StatN
  B_CALL Mov9ToOP1
  ld a,8
  ld (penrow),a
  ld a,15
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,MinX
  B_CALL Mov9ToOP1
  ld a,16
  ld (penrow),a
  ld a,15
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,Q1
  B_CALL Mov9ToOP1
  ld a,24
  ld (penrow),a
  ld a,15
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,MedX
  B_CALL Mov9ToOP1
  ld a,32
  ld (penrow),a
  ld a,32
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,Q3
  B_CALL Mov9ToOP1
  ld a,40
  ld (penrow),a
  ld a,15
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,MaxX
  B_CALL Mov9ToOP1
  ld a,48
  ld (penrow),a
  ld a,15
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  B_CALL GetKey
  B_CALL ClrLCDFull
  jp finish
;--------------------------
;-          IQR           -
;--------------------------
IQRstrt:
  ld HL,IQRtext
  ld a,0
  ld (pencol),a
  ld a,0
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,8
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,16
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,24
  ld (penrow),a
  call vputs0
  ld a,0
  ld (pencol),a
  ld a,32
  ld (penrow),a
  call vputs0
;numerical formatting
  ld a,0
  ld (pencol),a
  ld (penrow),a
  ld HL,0
  call ovs
  ld HL,Q1
  B_CALL Mov9ToOP1
  ld a,8
  ld (penrow),a
  ld a,15
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,MedX
  B_CALL Mov9ToOP1
  ld a,16
  ld (penrow),a
  ld a,30
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,Q3
  B_CALL Mov9ToOP1
  ld a,24
  ld (penrow),a
  ld a,15
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,Q3
  B_CALL Mov9ToOP1
  ld a,40
  ld (penrow),a
  ld a,0
  ld (pencol),a
  ld a,9
  B_CALL DispOP1A
  ld HL,subt
  call vputs0
  ld HL,Q1
  B_CALL Mov9ToOP1
  ld a,9
  B_CALL DispOP1A
  ld HL,equl
  call vputs0
  ld HL,Q1
  B_CALL Mov9ToOP1
  B_CALL OP1ToOP2
  ld HL,Q3
  B_CALL Mov9ToOP1
  B_CALL FPSub
  ld a,9
  B_CALL DispOP1A
  B_CALL GetKey
  B_CALL ClrLCDFull
  jp finish
meanstrt:
;+----------------------------+
;|        Sample Mean         |
;+----------------------------+
;Text formatting
  LD HL,plotSScreen
  B_CALL BufClr
  set textWrite, (IY + sGrFlags)
  call ovs
  ld a,14
  ld (penrow),a
  ld a,13
  ld (pencol),a
  ld HL,Means4
  call vputs0
  ld HL,StatN
  B_CALL Mov9ToOP1
  ld a,9
  B_CALL DispOP1A
  ld HL,Means
  ld a,0
  ld (pencol),a
  ld a,0
  ld (penrow),a
  call vputs0
  ld a,11
  ld (penrow),a
  ld a,2
  ld (pencol),a
  ld HL,Means2
  call vputs0
  ld a,21
  ld (pencol),a
  ld HL,Means5
  call vputs0
  ld a,6
  ld (pencol),a
  ld a,20
  ld (penrow),a
  ld HL,Means5
  call vputs0
  ld HL,XMean
  B_CALL Mov9ToOP1
  ld a,9
  B_CALL DispOP1A
  ld a,7
  ld (penrow),a
  ld a,11
  ld (pencol),a
  ld HL,Means3
  call vputs0
  ld HL,SumX
  B_CALL Mov9ToOP1
  ld a,9
  B_CALL DispOP1A
  B_CALL GrBufCpy
  ld H,1
  ld b,11
  ld c,49
  ld d,18
  ld e,49
  B_CALL ILine
  call unl
  ld d,a
  ld b,25
  ld c,49
  ld e,49
  ld h,1
  B_CALL ILine
  B_CALL GetKey
  B_CALL ZeroOP1
  B_CALL ZeroOP2
  B_CALL ZeroOP3
  ld HL,2
  B_CALL DeallocFPS
  B_CALL ClrLCDFull
  res textWrite, (IY + sGrFlags)
  jp finish
varstrt:
;+----------------------------+
;|       Sample Variance      |
;+----------------------------+
;Text formatting
  ld h,1
  ld b,13
  ld c,43
  ld d,24
  ld e,43
  B_CALL ILine
  ld b,13
  ld c,26
  ld d,24
  ld e,26
  B_CALL ILine
  ld HL,variance1
  ld a,0
  ld (pencol),a
  ld a,0
  ld (penrow),a
  call vputs0
  ld HL,variance2
  ld a,0
  ld (pencol),a
  ld a,17
  ld (penrow),a
  call vputs0
  ld HL,variance3
  ld a,16
  ld (pencol),a
  ld a,13
  ld (penrow),a
  call vputs0
  ld HL,variance4
  ld a,13
  ld (pencol),a
  ld a,21
  ld (penrow),a
  call vputs0
  ld HL,variance5
  ld a,26
  ld (pencol),a
  ld a,17
  ld (penrow),a
  call vputs0
  ld HL,equl
  ld a,8
  ld (pencol),a
  ld a,34
  ld (penrow),a
  call vputs0
  ld HL,variance3
  ld a,14
  ld (pencol),a
  ld a,30
  ld (penrow),a
  call vputs0
  ld HL,variance4
  ld a,14
  ld (pencol),a
  ld a,38
  ld (penrow),a
  call vputs0
  ld HL,mult
  ld a,26
  ld (pencol),a
  ld a,34
  ld (penrow),a
  call vputs0
  call ovs
  ld HL,StdX
  B_CALL Mov9ToOP1
  B_CALL FPSquare
  B_CALL PushRealO1
  ld HL,StatN
  B_CALL Mov9ToOP1
  B_CALL Minus1
  B_CALL OP1ToOP2
  B_CALL PopRealO1
  B_CALL FPMult
  ld a,9
  B_CALL DispOP1A
  ld HL,equl
  call vputs0
  ld HL,StdX
  B_CALL Mov9ToOP1
  B_CALL FPSquare
  ld a,9
  B_CALL DispOP1A
  B_CALL GetKey
  jp finish
devstrt:
;+----------------------------+ 
;|     Standard Deviation     |
;+----------------------------+
  B_CALL ClrLCDFull
  LD HL,plotSScreen
  B_CALL BufClr
  B_CALL ClrLCDFull
  ld h,1
  ld b,12
  ld c,43
  ld d,24
  ld e,43
  B_CALL ILine
  ld b,11
  ld c,33
  ld d,11
  ld e,20
  B_CALL ILine
  ld b,14
  ld c,26
  ld d,24
  ld e,26
  B_CALL ILine
  ld b,10
  ld c,37
  ld d,10
  ld e,51
  B_CALL ILine
  ld b,10
  ld c,51
  ld d,56
  ld e,51
  B_CALL ILine
  ld b,7
  ld c,40
  ld d,9
  ld e,38
  B_CALL ILine
  ld b,44
  ld c,34
  ld d,11
  ld e,34
  B_CALL ILine
  ld b,10
  ld c,21
  ld d,8
  ld e,24
  B_CALL ILine
  ld HL,stdev
  ld a,0
  ld (pencol),a
  ld a,0
  ld (penrow),a
  call vputs0
  ld HL,stdev2
  ld a,0
  ld (pencol),a
  ld a,17
  ld (penrow),a
  call vputs0
  ld HL,variance3
  ld a,16
  ld (pencol),a
  ld a,13
  ld (penrow),a
  call vputs0
  ld HL,variance4
  ld a,13
  ld (pencol),a
  ld a,21
  ld (penrow),a
  call vputs0
  ld HL,variance5
  ld a,26
  ld (pencol),a
  ld a,17
  ld (penrow),a
  call vputs0
  ld HL,equl
  ld a,5
  ld (pencol),a
  ld a,34
  ld (penrow),a
  call vputs0
  ld HL,variance3
  ld a,17
  ld (pencol),a
  ld a,30
  ld (penrow),a
  call vputs0
  ld HL,variance4
  ld a,14
  ld (pencol),a
  ld a,38
  ld (penrow),a
  call vputs0
  ld HL,mult
  ld a,26
  ld (pencol),a
  ld a,34
  ld (penrow),a
  call vputs0
  call ovs
  ld HL,StdX
  B_CALL Mov9ToOP1
  B_CALL FPSquare
  B_CALL PushRealO1
  ld HL,StatN
  B_CALL Mov9ToOP1
  B_CALL Minus1
  B_CALL OP1ToOP2
  B_CALL PopRealO1
  B_CALL FPMult
  ld a,9
  B_CALL DispOP1A
  ld HL,equl
  call vputs0
  ld HL,StdX
  B_CALL Mov9ToOP1
  ld a,9
  B_CALL DispOP1A
  B_CALL GetKey
  jp finish
outlstrt:
;+----------------------------+ 
;|    Test For Outliers       |
;+----------------------------+
  B_CALL ClrLCDFull
  ld HL,out1
  ld a,0
  ld (pencol),a
  ld a,0
  ld (penrow),a
  call vputs0
  ld HL,out2
  ld a,0
  ld (pencol),a
  ld a,6
  ld (penrow),a
  call vputs0
  ld HL,out3
  ld a,0
  ld (pencol),a
  ld a,12
  ld (penrow),a
  call vputs0
  ld HL,out4
  ld a,0
  ld (pencol),a
  ld a,18
  ld (penrow),a
  call vputs0
  ld HL,out5
  ld a,0
  ld (pencol),a
  ld a,24
  ld (penrow),a
  call vputs0
  ld HL,out6
  ld a,0
  ld (pencol),a
  ld a,30
  ld (penrow),a
  call vputs0
  ld HL,Q1
  B_CALL Mov9ToOP1
  ld a,9
  B_CALL DispOP1A
  ld HL,out7
  call vputs0
  ld HL,Q1
  B_CALL Mov9ToOP1
  B_CALL OP1ToOP2
  ld HL,Q3
  B_CALL Mov9ToOP1
  B_CALL FPSub
  ld a,9
  B_CALL DispOP1A
  ld HL,out8
  call vputs0
  ld HL,Q1
  B_CALL Mov9ToOP1
  B_CALL OP1ToOP2
  ld HL,Q3
  B_CALL Mov9ToOP1
  B_CALL FPSub
  B_CALL OP1ToOP2
  ld HL,onenahalf
  B_CALL Mov9ToOP1
  B_CALL FPMult
  B_CALL OP1ToOP2
  ld HL,Q1
  B_CALL Mov9ToOP1
  B_CALL OP1ExOP2
  B_CALL FPSub
  ld a,9
  B_CALL DispOP1A
  ld HL,out3
  ld a,0
  ld (pencol),a
  ld a,36
  ld (penrow),a
  call vputs0
  ld HL,out9
  ld a,0
  ld (pencol),a
  ld a,42
  ld (penrow),a
  call vputs0
  ld HL,Q3
  B_CALL Mov9ToOP1
  ld a,9
  B_CALL DispOP1A
  ld HL,out10
  call vputs0
  ld HL,Q1
  B_CALL Mov9ToOP1
  B_CALL OP1ToOP2
  ld HL,Q3
  B_CALL Mov9ToOP1
  B_CALL FPSub
  ld a,9
  B_CALL DispOP1A
  ld HL,out11
  call vputs0
  ld HL,Q1
  B_CALL Mov9ToOP1
  B_CALL OP1ToOP2
  ld HL,Q3
  B_CALL Mov9ToOP1
  B_CALL FPSub
  B_CALL OP1ToOP2
  ld HL,onenahalf
  B_CALL Mov9ToOP1
  B_CALL FPMult
  B_CALL OP1ToOP2
  ld HL,Q3
  B_CALL Mov9ToOP1
  B_CALL FPAdd
  ld a,9
  B_CALL DispOP1A
  B_CALL GetKey
  jp finish
;+----------------------------+ 
;|   Various Sub-Ruitines     |
;+----------------------------+
unl:
;underline Number Sub-Ruitine
;b=row you number is displayed at minus two or three
;returns the x position of the end of the line in reg c
  ld HL,2
  B_CALL AllocFPS
  ld HL,eleven
  B_CALL Mov9ToOP1
  B_CALL PushRealO1
  ld HL,cantspell
  B_CALL Mov9ToOP1
  B_CALL OP1ToOP2
  B_CALL PushRealO1
  B_CALL PopRealO1
  B_CALL PopRealO1
pxtest:
  B_CALL OP2ToOP1
  ld HL,eleven
  B_CALL Mov9ToOP1
  B_CALL PushRealO1
  B_CALL OP2ToOP1
  B_CALL Minus1
  B_CALL OP1ToOP2
  B_CALL PushRealO1
  B_CALL PixelTest
  jp z,pxtest
  jp doneunl
doneunl:
  B_CALL OP2ToOP1
  B_CALL ConvDim
  ret

cantspell:
  db 00h,81h,75h,00h,00h,00h,00h,00h,00h
eleven:
  db 00h,81h,12h,00h,00h,00h,00h,00h,00h
onenahalf:
  db 00h,80h,15h,00h,00h,00h,00h,00h,00h
stupid:
  ld a,8
  ld (pencol),a
  ld (penrow),a
  ld HL,ss
  call vputs0
  B_CALL GetKey
  jp finish
ss:
  db "There is no data in L1.",0

;Small Text Display Sub-Ruitine
vputs0:
  PUSH AF
  PUSH DE
  PUSH IX
VPutS1:
  LD A,(HL)
  INC HL
  OR A
  JR Z, VputS2
  B_CALL VPutMap
  JR NC, VPutS1
VputS2:
  POP IX
  POP DE
  POP AF  
  ret
;calculates 1-var Statistics

ovs:
  B_CALL ZeroOP1
  ld a,1
  LD HL,L1name
  B_CALL Mov9ToOP1 ; OP1 = L1
  B_CALL OneVar ; execute 1-variable stats
  ret

;L1 Variable Definition
L1name: DB ListObj,tVarLst,tL1,0,0
; Strings
fns1:
  db "Five Number Summary",0,"n: ",0,"Min: ",0,"Q1: ",0,"Median: ",0,"Q3: ",0,"Max: ",0
IQRtext:
  db "IQR",0,"Q1:",0,"Median:",0,"Q3:",0,"Q3-Q1 = IQR",0
Means:
  db "Sample Mean:",0
Means2:
  db SxMean,"=",0
Means3:
  db ScapSigma,"x       ",0
Means4:
  db "n         ",0
Means5:
  db "=",0
subt:
  db "-",0
equl:
  db "=",0
variance1:
  db "Sample Variance:",0
variance2:
  db "s",Sarea,"=",0
variance3:
  db "1",0
variance4:
  db "n-1",0
variance5:
  db ScapSigma,"(x-",SxMean,")",Sarea,0
mult:
  db "*",0
stdev:
  db "Standard Deviation:",0
stdev2:
  db Ssigma,"=",0
out1:
  db "Test for Outliners:",0
out2:
  db "Outliners<Q1-(1.5*IQR)",0
out3:
  db "or",0
out4:
  db "Outliners>Q3+(1.5*IQR)",0
out5:
  db "Therefore",0
out6:
  db "Outliners<",0
out7:
  db "-(1.5*",0
out8:
  db ")=",0
out9:
  db "Outliners>",0
out10:
  db "+(1.5*",0
out11:
  db ")=",0

finish:
  B_CALL ZeroOP1
  ret
